---
# Copyright 2017-present Open Networking Foundation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

{{- range $i, $junk := until (.Values.numOlts|int) }}
---
apiVersion: v1
kind: Service
metadata:
   name: olt{{ $i }}
   namespace: {{ $.Values.global.namespace }}
   labels:
     name: olt{{ $i }}
spec:
  ports:
    - name: grpc
      port: 50060
      targetPort: 50060
  selector:
    olt: olt{{ $i }}
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: olt{{ $i }}
  namespace: {{ $.Values.global.namespace }}
spec:
   replicas: 1
   selector:
     matchLabels:
       app: ponsim
       olt: olt{{ $i }}
   template:
     metadata:
       labels:
         app: ponsim
         olt: olt{{ $i }}
       annotations:
         cni: "calico,nni{{ $i }}"
     spec:
       affinity:
        podAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 100
            podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: app
                  operator: In
                  values:
                  - mininet
              topologyKey: kubernetes.io/hostname
       containers:
         - name: olt{{ $i }}
           image: "{{ $.Values.global.registry }}{{ $.Values.images.olt.repository }}:{{ tpl $.Values.images.olt.tag $ }}"
           imagePullPolicy: {{ $.Values.images.olt.pullPolicy }}
           env:
             - name: POD_IP
               valueFrom:
                 fieldRef:
                   fieldPath: status.podIP
             - name: NAMESPACE
               valueFrom:
                 fieldRef:
                   fieldPath: metadata.namespace
           args:
             - "/app/ponsim"
             - "-device_type"
             - "OLT"
             - "-onus"
             - "4"
             - "-internal_if"
             - "eth1"
             - "-external_if"
             - "eth1"
             - "-vcore_endpoint"
             - "vcore"
             - "-promiscuous"
           ports:
            - containerPort: 50060
              name: grpc-port
{{- end }}
